package de.lmu.ifi.pms.cep;

import org.simpleframework.xml.stream.Format;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.lmu.ifi.pms.cep.tsa.DTSA_BufferType;


public final class COMMON_CONSTANTS {

	private COMMON_CONSTANTS(){
		
	}
	
	public final static String BASE_LOGGER_NAME = COMMON_CONSTANTS.class.getPackage().getName();
	public final static Logger BASE_LOGGER = LoggerFactory.getLogger(BASE_LOGGER_NAME);
	
	public final static String LOG_FILE_TIMESTAMP_PROPERTY = "logFileTimestamp";
	public final static String LOG_FILE_DIR_PROPERTY = "logFileDir";
	public final static String LOG_FILE_TIMESTAMP_PATTERN = "yyyyMMdd'-'HHmmss'-'SSS";
	
	public final static Format SERIALIZATION_FORMAT = new Format("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
	
	public final static String SYSTEM_CLOCK_NAME = "system";
	
	public final static String TUPLE_ID_CLOCK_NAME = "tuple_id_seq";
	
	public static String BLOCK_COUNTER_CLOCK_NAME(final DTSA_BufferType type, final String buffer_full_name){
		return "buffer:" + type.name() + ":" + buffer_full_name;
	}
	
}
