package de.lmu.ifi.pms.cep.dura;

import org.simpleframework.xml.Attribute;

import de.lmu.ifi.pms.cep.compilation.Compiler;
import de.lmu.ifi.pms.cep.compilation.CompilerFactory;
import de.lmu.ifi.pms.cep.tsa.TSA_Program;

public class Dura_TSA_CompilerFactory extends CompilerFactory<String[], TSA_Program>{
	
	public static final String defaultIdentifier = "de.lmu.ifi.pms.cep.dura.compiler.tsa";
	
	public Dura_TSA_CompilerFactory() {
		this(defaultIdentifier);
	}
	
	public Dura_TSA_CompilerFactory(@Attribute(name="iri", required=true) final String identifier) {
		super(String[].class, TSA_Program.class, identifier);
	}
	
	@Override
	public Compiler<String[], TSA_Program> make() {
		return new Dura_TSA_Compiler();
	}
	
}
