package de.lmu.ifi.pms.cep.dura.compiler.durac.token_mappings;

import de.lmu.ifi.pms.cep.COMMON_CONSTANTS;
import de.lmu.ifi.pms.cep.tsa.conditions.ClockFunction;
import de.lmu.ifi.pms.cep.tsa.conditions.SequenceFunction;
import de.lmu.ifi.pms.cep.tsa.conditions.TimeFunction;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;


public class DuraDefaultAttributeNameMapping {
	public static final String identifierAttribute = "id";

	public static final String intervalBeginAttribute = "begin";
	public static final String intervalEndAttribute = "end";

	public static final String eventIdentifierPrefix = "event";
	public static final String stateIdentifierPrefix = "state";
	public static final String actionIdentifierPrefix = "action";

	public static final String labelSeparator = "$";
	public static final String identifierSeparator = "-";

	public static final String eventIntervalName = "reception-time";
	public static final String actionIntervalName = "initiation-time";
	
	public static final String payloadLabel = "payload";
	
	public static final String setLabel = "set";
	public static final String queryLabel = "query";
	
	public static final String valuesLabel = "payload";
	public static final String oldValuesLabel = "old-payload";
	public static final String newValuesLabel = "new-payload";

	public static final String soCreateSuffix = "create";
	public static final String soCreatedSuffix = "created";
	public static final String soTerminateSuffix = "terminate";
	public static final String soTerminatedSuffix = "terminated";
	public static final String soUpdateSuffix = "update";
	public static final String soUpdatedSuffix = "updated";
	
	public static final String actionInitiatedSuffix = "initiated";
	public static final String actionSucceededSuffix = "succeeded";
	public static final String actionFailedSuffix = "failed";
	public static final String actionCandidateSuffix = "candidate";
	
	public static final ClockFunction identifierClock = new SequenceFunction(COMMON_CONSTANTS.TUPLE_ID_CLOCK_NAME, BasicTypeID.IDENTIFIER);
	public static final ClockFunction timeClock = new TimeFunction(COMMON_CONSTANTS.SYSTEM_CLOCK_NAME, BasicTypeID.TIMESTAMP);

	public static final String identifierClockDuraName = COMMON_CONSTANTS.TUPLE_ID_CLOCK_NAME;
	public static final String identifierClockTSAName = COMMON_CONSTANTS.TUPLE_ID_CLOCK_NAME;
	public static final String systemTimeClockDuraName = "now";
	public static final String systemTimeClockTSAName = COMMON_CONSTANTS.SYSTEM_CLOCK_NAME;
}
