package de.lmu.ifi.pms.cep.event_mill.configuration;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Root;

import de.lmu.ifi.pms.java.util.adaption.CollectionAdapter;
import de.lmu.ifi.pms.java.util.map.Entry;
import de.lmu.ifi.pms.java.util.map.Map;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;


@Root
class Property {

	@Attribute
	final String key;
	@Attribute
	final String value;
	
	Property(@Attribute(name="key") final String key,@Attribute(name="value") final String value) {
		super();
		this.key = key;
		this.value = value;
	}
	
	public static java.util.ArrayList<Property> serialize(final Map<String, String, ?> properties){
		return new java.util.ArrayList<Property>(new CollectionAdapter<Entry<String, String>, Property>(properties) {

			@Override
			public Property adapt(final Entry<String, String> source) {
				return new Property(source.key(), source.value());
			}
			
		}.javaCollection());
	}
	
	public static FixedArrayNavigableMap<String, String> get(final java.util.ArrayList<Property> properties){
		if(properties==null){
			return null;
		}
		else{
			final int size = properties.size();
			final String[] keys = new String[size];
			final String[] values = new String[size];
			
			Property currentProperty;
			for(int index = 0; index < size; ++index){
				currentProperty = properties.get(index);
				keys[index] = currentProperty.key;
				values[index] = currentProperty.value;
			}
			
			return new FixedArrayNavigableMap<String, String>(keys, values);
		}
	}
	
}
