package de.lmu.ifi.pms.cep.event_mill.execution.dummy;

import de.lmu.ifi.pms.cep.event_mill.execution.program.StreamBuffer;
import de.lmu.ifi.pms.cep.tsa.DTSA_BufferType;
import de.lmu.ifi.pms.cep.tsa.time.Clock;
import de.lmu.ifi.pms.cep.tsa.time.SystemClock;

import de.lmu.ifi.pms.java.math.Math;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArraySet;

public class DummyStreamBuffer extends StreamBuffer<DummyStreamBuffer, DummyExecutableQuery, DummyExecutableProgram>{
	
	public final int id;
	
	protected long tupleCounter;
	protected long size;
	
	protected FixedArraySet<DummyExecutableQuery> inputQueries;
	protected FixedArraySet<DummyExecutableQuery> outputQueries;
	
	//protected final Clock tuple_id_seq;
	
//	public SQL_StreamBuffer(CERA_MaterialisationPoint materialisationPoint, SQL_StreamBufferStore bufferStore) {
//		this(materialisationPoint, bufferStore, materialisationPoint.Name);
//	}
	protected Clock systemClock = new SystemClock();

	public DummyStreamBuffer(final DummyExecutableProgram program, final int id, final DTSA_BufferType type, final String prog_package, final String simple_name) {
		super(prog_package, simple_name, type, program);
		
		this.id = id;
		
		this.tupleCounter = 0;
		//FIXME init buffer size
		this.size = 0;
		
		this.inputQueries = new FixedArraySet<DummyExecutableQuery>();
		this.outputQueries = new FixedArraySet<DummyExecutableQuery>();
		
		//FIXME
		//this.tuple_id_seq = program.clocks.get(SQL_Translation.tupleIdSeqenceName);
		
		this.program.register(this);
	}
	
	public synchronized long progress(){
		if(this.type == DTSA_BufferType.INPUT){
			return this.systemClock.min();
		}
		else{
			long progress = Math.MaxLongValue;
			long queryProgress;
			for(DummyExecutableQuery query: this.inputQueries){
				queryProgress = query.progress();
				if(queryProgress < progress){
					progress = queryProgress;
				}
			}
			return progress;
		}
	}

	
	@Override
	public synchronized FixedArraySet<DummyExecutableQuery> inputQueries()
	{
		return this.inputQueries;
	}
	
	public synchronized void RegisterInputQuery(final DummyExecutableQuery query){
		DummyExecutableQuery[] inputQueries = new DummyExecutableQuery[this.inputQueries.size() + 1];
		for(int input = 0; input < this.inputQueries.size(); ++input){
			if(query == this.inputQueries.get(input)){//TODO better test?
				return;
			}
			inputQueries[input] = this.inputQueries.get(input);
		}
		inputQueries[inputQueries.length - 1] = query;
		this.inputQueries = new FixedArraySet<DummyExecutableQuery>(false, false, inputQueries);
	}
	
	@Override
	public synchronized FixedArraySet<DummyExecutableQuery> outputQueries()
	{
		return this.outputQueries;
	}
	
	public synchronized void RegisterOutputQuery(final DummyExecutableQuery query){
		DummyExecutableQuery[] outputQueries = new DummyExecutableQuery[this.outputQueries.size() + 1];
		for(int output = 0; output < this.outputQueries.size(); ++output){
			if(query == this.outputQueries.get(output)){//TODO better test?
				return;
			}
			outputQueries[output] = this.outputQueries.get(output);
		}
		outputQueries[outputQueries.length - 1] = query;
		this.outputQueries = new FixedArraySet<DummyExecutableQuery>(false, false, outputQueries);
	}
	
	public synchronized void notifyRead(){
	
	}
	
	public synchronized void notifyWrite(final long tupleNumber){
		if(tupleNumber > 0){
			this.tupleCounter += tupleNumber;
		}
		this.size += tupleNumber;
		
		assert(true); //FIXME check whether this.size == SELECT COUNT() FROM
	}
	
	protected synchronized long tupleCount(){
		return this.tupleCounter;
	}
	
	@Override
	public boolean exists(){
		return true;
	}
	
	@Override
	public boolean isEmpty(){
		return this.size == 0;
	}
	

	@Override
	public void clear()
	{
		
	}
	
}
