package de.lmu.ifi.pms.cep.event_mill.io.bus;

import java.lang.reflect.Array;

import org.slf4j.Logger;

import de.lmu.ifi.pms.cep.event_mill.io.MessageSink;
import de.lmu.ifi.pms.cep.event_mill.io.MessageSource;
import de.lmu.ifi.pms.cep.event_mill.io.format.MessageFormatProvider;

import de.lmu.ifi.pms.java.LoggingObject;

public abstract class MessageBus<MessageType> extends LoggingObject{
	
	public final Class<MessageType> type;
	
	protected final MessageBusProvider providerReference;
	
	public MessageBus(final Class<MessageType> type, final MessageBusProvider provider) {
		super();
		this.type = type;
		this.providerReference = provider;
	}
	
	@SuppressWarnings("unchecked")
	public final MessageType[] newBlock(final int size){
		return (MessageType[])Array.newInstance(this.type, size);
	}

	public abstract MessageFormatProvider<MessageType> formatter();
	
	public abstract MessageSink<MessageType> sink();
	
	public abstract MessageSource<MessageType> source();
	
	@Override
	protected abstract Logger logger();

}
