package de.lmu.ifi.pms.cep.event_mill.io.bus;

import java.util.Arrays;

import de.lmu.ifi.pms.cep.event_mill.io.MessageAdapter;
import de.lmu.ifi.pms.cep.event_mill.io.MessageSource;



public class WrapperMessageSource<MessageType1, MessageType2> extends MessageSource<MessageType2>{
	
	public final MessageAdapter<MessageType1, MessageType2> readAdapter;
	final MessageSource<MessageType1> source;

	public WrapperMessageSource(final MessageAdapter<MessageType1, MessageType2> readAdapter, final MessageSource<MessageType1> source) {
		super(readAdapter.type2);
		this.readAdapter = readAdapter;
		this.source = source;
	}
	
	@Override
	public MessageType2 read() {
		MessageType1 message1 = this.source.read();
		while(message1 != null){
			MessageType2 message2 = this.readAdapter.adapt(message1);
			if(message2 != null){
				return message2;
			}
			message1 = this.source.read();
		}
		return null;
	}
	
	@Override
	public MessageType2[] readBlock() {
		MessageType1[] block1 = this.source.readBlock();
		MessageType2[] block2 = this.newBlock(block1.length);
		MessageType2 message2;
		int index2 = 0;
		for(int index1 = 0; index1 < block1.length; ++index1){
			message2 = this.readAdapter.adapt(block1[index1]);
			if(message2 != null){
				block2[index2] = message2;
				++index2;
			}
		}
		if(index2 < block2.length){
			return Arrays.copyOf(block2, index2);
		}
		else{
			return block2;
		}
	}
	
	@Override
	public void close() {
		this.source.close();
	}
	
}
