package de.lmu.ifi.pms.cep.event_mill.io.format;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementUnion;

import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;

import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;

public class MessageFormatAliasProvider<MessageType> extends MessageFormatProvider<MessageType> {
	
	@ElementUnion({
		@Element(name="alias", type=MessageFormatAliasProvider.class),
		@Element(name="format", type=MessageFormatProvider.class)
	})
	public final MessageFormatProvider<MessageType> format;	

	public MessageFormatAliasProvider(@Attribute(name="iri", required=false)  final String identifier, @Element(name="format", type=MessageFormatProvider.class) final MessageFormatProvider<MessageType> format) {
		super(format.type, identifier);
		if(identifier == null){
			throw new IllegalArgumentException();
		}
		this.format = format;
	}

	@Override
	public MessageGenerator<MessageType> messageGenerator(final String messageType, final FixedArrayNavigableMap<String, BasicTypeID> types) {
		return this.format.messageGenerator(messageType, types);
	}

	@Override
	public MessageReader<MessageType> messageReader(final String messageType, final FixedArrayNavigableMap<String, BasicTypeID> types) {
		return this.format.messageReader(messageType, types);
	}

	@Override
	public String messageType(final MessageType message) {
		return this.format.messageType(message);
	}

}
