package de.lmu.ifi.pms.cep.event_mill.io.stream;

import org.slf4j.Logger;

import de.lmu.ifi.pms.cep.event_mill.io.format.MessageFormatProvider;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;


public abstract class SourceStream extends Stream{
	
	public SourceStream(final String name, final FixedArrayNavigableMap<String, BasicTypeID> types){
		super(name, types);
	}
	
	public SourceStream(final String name, final FixedArray<String> parameters, final FixedArray<BasicTypeID> types) {
		super(name, parameters, types);
	}
	
	public <MessageType> MessageSourceStream<MessageType> format(final MessageFormatProvider<MessageType> formatProvider){
		return new MessageSourceStream<MessageType>(this, formatProvider);
	}
	
	public abstract boolean nextBlock();
	
	public abstract boolean next();
	
	public abstract String getString(final int parameterIndex);

	
	public abstract boolean getBoolean(final int parameterIndex);

	
	public abstract byte getByte(final int parameterIndex);

	
	public abstract short getShort(final int parameterIndex);

	
	public abstract int getInt(final int parameterIndex);

	
	public abstract long getLong(final int parameterIndex);
	
	public abstract long getTimestamp(final int parameterIndex);
	
	public abstract long getDuration(final int parameterIndex);
	
	public abstract long getIdentifier(final int parameterIndex);

	
	public abstract float getFloat(final int parameterIndex);

	
	public abstract double getDouble(final int parameterIndex);

	
	public String getString(final String columnLabel) {
		return this.getString(this.findColumn(columnLabel));
	}

	
	public boolean getBoolean(final String columnLabel) {
		return this.getBoolean(this.findColumn(columnLabel));
	}

	
	public byte getByte(final String columnLabel) {
		return this.getByte(this.findColumn(columnLabel));
	}

	
	public short getShort(final String columnLabel) {
		return this.getShort(this.findColumn(columnLabel));
	}

	
	public int getInt(final String columnLabel) {
		return this.getInt(this.findColumn(columnLabel));
	}

	
	public long getLong(final String columnLabel) {
		return this.getLong(this.findColumn(columnLabel));
	}
	
	public long getTimestamp(final String columnLabel) {
		return this.getLong(this.findColumn(columnLabel));
	}
	
	public long getDuration(final String columnLabel) {
		return this.getLong(this.findColumn(columnLabel));
	}
	
	public long getIdentifier(final String columnLabel) {
		return this.getLong(this.findColumn(columnLabel));
	}

	
	public float getFloat(final String columnLabel) {
		return this.getFloat(this.findColumn(columnLabel));
	}

	
	public double getDouble(final String columnLabel) {
		return this.getDouble(this.findColumn(columnLabel));
	}

	
//	public boolean isFirst() {
//
//	}
//
//	
//	public boolean isLast() {
//
//	}

	
//	public void setFetchSize(final int rows) {
//
//	}
//
//	
//	public int getFetchSize() {
//
//	}
	
	@Override
	protected abstract Logger logger();

}