package de.lmu.ifi.pms.cep.tsa.conditions;

import de.lmu.ifi.pms.cep.tsa.schema.BasicType;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;

public class BasicTypeVariable extends TypedVariable<BasicType> {
	
	@SuppressWarnings("hiding")
	public final BasicTypeID ID; 
	
	protected BasicTypeVariable(final String name, final BasicTypeID typeID) {
		super(name, typeID.type);
		this.ID = typeID;
	}
	
	public static BasicTypeVariable create(final String name, final BasicType type){
		return create(name, type.ID);
	}
	
	public static BasicTypeVariable create(final String name, final BasicTypeID typeID){
		return new BasicTypeVariable(name, typeID);
	}

	@Override
	public BasicTypeVariable rename(final String newName) {
		return BasicTypeVariable.create(newName, this.ID);
	}
}
