package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.AType;

public class Max<TypeClass extends AType> extends AggregationFunction<TypeClass> {

	public Max(final TypeClass type, final Term<?> argument) {
		super(AggregationFunctionID.MAX, type, argument);
	}
	
	Max(@Element(name="type") final TypeClass type, @ElementList(entry="term", inline=true, required=false, empty=false) final java.util.ArrayList<Term<?>> arguments) {
		super(AggregationFunctionID.MAX, type, arguments);
	}
	
	@Override
	protected Max<TypeClass> newTerm(final Term<?> argument) {
		return new Max<TypeClass>(this.type, argument);
	}

}
