package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.AType;
import de.lmu.ifi.pms.cep.tsa.schema.NoType;


public class Minus<TypeClass extends AType> extends TupleFunction<TypeClass> {

	public Minus(final TypeClass type, final Term<?>  argument1, final Term<?>  argument2) {
		super(TupleFunctionID.MINUS, type, argument1, argument2);
	}
	
	@SuppressWarnings("unchecked")
	Minus(@Element(name="type", required=false) final TypeClass type, @ElementList(entry="term", inline=true, required=false, empty=false)  final java.util.ArrayList<Term<?>> arguments) {
		super(TupleFunctionID.MINUS, (type==null ? (TypeClass)NoType.instance : type), arguments);
	}
	
	@Override
	public Minus<TypeClass> newTerm(final Term<?> ... arguments) {
		return new Minus<TypeClass>(this.type, arguments[0],arguments[1]);
	}

}