package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.AType;



public class UserAggregationFunction<TypeClass extends AType> extends AggregationFunction<TypeClass> {
	
	@Attribute(name="name")
	String getName(){
		return this.name;
	}
	
	public UserAggregationFunction(final String name, final TypeClass type, final Term<?> argument) {
		super(AggregationFunctionID.USER, name, type, argument);
	}
	
	UserAggregationFunction(@Attribute(name="name")final String name, @Element(name="type") final TypeClass type, @ElementList(entry="term", inline=true, required=false, empty=false) final java.util.ArrayList<Term<?>> arguments) {
		super(AggregationFunctionID.USER, name, type, arguments);
	}

	@Override
	protected UserAggregationFunction<TypeClass> newTerm(final Term<?> argument) {
		return new UserAggregationFunction<TypeClass>(this.name, this.type, argument);
	}
}
