package de.lmu.ifi.pms.cep.tsa.conditions.adaptor;

import de.lmu.ifi.pms.cep.tsa.TSA_SyntaxPatterns;
import de.lmu.ifi.pms.cep.tsa.conditions.AtomicTerm;
import de.lmu.ifi.pms.cep.tsa.conditions.Attribute;
import de.lmu.ifi.pms.java.util.adaption.Adapter;

public class PrefixAttributes implements Adapter<AtomicTerm<?>, AtomicTerm<?>>{
	
	public final String prefix;
	
	public PrefixAttributes(final String prefix) {
		super();
		if(prefix.equals("") | TSA_SyntaxPatterns.isValidAttributeName(prefix)){
			this.prefix = prefix;
		}
		else{
			throw new IllegalArgumentException();
			//TODO better exception
		}
	}

	@Override
	public AtomicTerm<?> adapt(final AtomicTerm<?> source) {
		if(this.prefix.equals("")){
			return source;
		}
		else{
			if(source instanceof Attribute){
				Attribute<?> attribute = (Attribute<?>) source;
				return attribute.rename(TSA_SyntaxPatterns.prefixAttribute(this.prefix, attribute.name));
			}
			else{
				return source;
			}
		}
	}

}
