package de.lmu.ifi.pms.cep.tsa.conditions.adaptor;

import de.lmu.ifi.pms.cep.tsa.conditions.AtomicTerm;
import de.lmu.ifi.pms.cep.tsa.conditions.Variable;
import de.lmu.ifi.pms.java.util.adaption.Adapter;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;

public class RenameVariables implements Adapter<AtomicTerm<?>, AtomicTerm<?>>{
	
	public final FixedArrayNavigableMap<String, String> mapping;
	
	public RenameVariables(final FixedArrayNavigableMap<String, String> mapping) {
		super();
		this.mapping = mapping;
	}

	@Override
	public AtomicTerm<?> adapt(final AtomicTerm<?> source) {
		if(source instanceof Variable<?>){
			Variable<?> var = (Variable<?>) source;
			int index = this.mapping.keys().indexOf(var.name);
			if(index >= 0){
				return var.rename(this.mapping.values().get(index));
			}
			else{
				return source;
			}
		}
		else{
			return source;
		}
	}

}
