package de.lmu.ifi.pms.cep.tsa.conditions.analysis;

import de.lmu.ifi.pms.cep.tsa.conditions.AtomicConditionFormula;
import de.lmu.ifi.pms.java.util.adaption.Adapter;
import de.lmu.ifi.pms.java.util.collection.AbstractCollection;
import de.lmu.ifi.pms.java.util.filter.AbstractFilter;
import de.lmu.ifi.pms.java.util.filter.Filter;

public abstract class SimpleFocusedFormulaAnalyser{
	
	public static Filter<AtomicConditionFormula> preAdaptFocus(final Adapter<AtomicConditionFormula, ? extends AtomicConditionFormula> localType){
		return new AbstractFilter<AtomicConditionFormula>() {
			
			@Override
			public boolean accepts(final AtomicConditionFormula element) {
				return localType.adapt(element) != null;
			}
			
		};
	}
	
	public Filter<AtomicConditionFormula> preAdaptFocus(){
		return preAdaptFocus(this.localType());
	}
	
	public abstract Adapter<AtomicConditionFormula, ? extends AtomicConditionFormula> localType();

	public abstract Filter<AtomicConditionFormula> postAdaptFocus();
	
	public abstract boolean isConsistent(AbstractCollection<AtomicConditionFormula> positiveLiterals, AbstractCollection<AtomicConditionFormula> negativeLiterals);
	
	//TODO variable elimination
	
}
