package de.lmu.ifi.pms.cep.tsa.time.analysis;

import de.lmu.ifi.pms.cep.tsa.conditions.ConditionFormula;

import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArrayNavigableSet;

public abstract class ArithmeticAnalyzerFactory {
	
	public ArithmeticAnalyzerFactory() {
		
	}

	public ArithmeticAnalyzer make(final ConditionFormula formula){
		return this.make(formula, new FixedArrayNavigableSet<String>(), new FixedArrayNavigableSet<String>());
	}
	
	public abstract ArithmeticAnalyzer make(final ConditionFormula formula, final FixedArrayNavigableSet<String> relevantAttributes, final FixedArrayNavigableSet<String> relevantVariables);
	
}
