package de.lmu.ifi.pms.cep.tsa.time.functions;

import org.simpleframework.xml.Attribute;



public final class ConstantTimeFunction extends TimeFunction {
	
	@Attribute(name="constant")
	public final long constant; 

	public ConstantTimeFunction(@Attribute(name="constant") final long constant) {
		super();
		assert TimeConstants.MIN_VALUE <= constant & constant <= TimeConstants.MAX_VALUE;
		this.constant = constant;
	}

	@Override
	public void apply(final long[] arguments, final int argStart, final long[] results, final int resultStart) {
		assert argStart >= 0;
		assert resultStart >= 0;
		assert arguments.length >= argStart + this.argumentArity();
		assert results.length >= resultStart + this.resultArity(); 
		
		results[resultStart] = this.constant;
	}

	@Override
	public final int argumentArity() {
		return 0;
	}

	@Override
	public final int resultArity() {
		return 1;
	}
	
}
