package de.lmu.ifi.pms.cep.tsa.time.functions;

import org.simpleframework.xml.Element;

public class Min extends SimpleTimeFunction {
	
	@Element(name="arity") 
	public final int arity;

	public Min(@Element(name="arity") final int arity) {
		super();
		this.arity = arity;
	}

	@Override
	long apply(final long[] arguments, final int argStart) {
		final int argEnd = argStart + this.arity;
		long min = TimeConstants.PLUS_INFINITY;
		long current;
		for(int index = argStart; index < argEnd; ++index){
			current = arguments[index];
			if(min > current){
				min = current;
			}
		}
		return min;
	}

	@Override
	public int argumentArity() {
		return this.arity;
	}

}
