package de.lmu.ifi.pms.java.lang.enumeration;

import java.util.NoSuchElementException;

public abstract class AbstractEnumerable<EnumerableType extends AbstractEnumerable<EnumerableType>> implements Enumerable<EnumerableType> {
	
	@Override
	public abstract int ordinal();
	
	@Override
	public int compareTo(final EnumerableType o){
		return this.ordinal() - o.ordinal();
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public final boolean equals(final Object obj){
		//TODO check Implementation
		return this.compareTo((EnumerableType) obj) == 0;
	}
	
	@Override
	public abstract boolean hasNext();
	
	// next().ordinal = this.ordinal() + 1
	@Override
	public abstract EnumerableType next();
	
	@Override
	@Deprecated
	public final void remove(){
		throw new UnsupportedOperationException();//TODO better exception
	}
	
	public static <E extends Enum<E>> boolean hasNext(final E e){
		return e.ordinal() < e.getClass().getEnumConstants().length;
	}
	
	@SuppressWarnings("unchecked")
	public static <E extends Enum<E>> E next(final E e){
		final Enum<E>[] constants = e.getClass().getEnumConstants();
		if(e.ordinal() +1 < constants.length){
			return (E) constants[e.ordinal()+1];
		}
		else{
			throw new NoSuchElementException();//TODO better exception
		}
	}

}
