package de.lmu.ifi.pms.java.lang.enumeration;

import de.lmu.ifi.pms.java.lang.iteration.FixedIterator;

public interface Enumerable<EnumerableType extends Enumerable<EnumerableType>> extends Comparable<EnumerableType>, FixedIterator<EnumerableType> {
	
	int ordinal();
	
	@Override
	int compareTo(EnumerableType o);
	
	@Override
	boolean equals(Object obj);
	
	@Override
	boolean hasNext();
	
	@Override
	EnumerableType next();
	
	@Override
	@Deprecated
	void remove();

}
