package de.lmu.ifi.pms.java.lang.iteration;

import java.util.Iterator;

import de.lmu.ifi.pms.java.util.collection.Collection;



public class CrossProductIterable<Type> extends AbstractIterable<Type[]> {
	
	private final Iterable<Type>[] iterations;
	public final Class<Type> type;
	
	public CrossProductIterable(final Class<Type> type, final Iterable<Type>... iterations){
		this.iterations = iterations;
		this.type = type;
	}
	
	@SuppressWarnings("unchecked")
	public CrossProductIterable(final Class<Type> type, final Collection<Iterable<Type>> iterations){
		this(type, iterations.toArray(new Iterable[iterations.size()]));
	}

	@Override
	public Iterator<Type[]> iterator() {
		return new FixedCrossProductArrayIterator<Type>(this.type, this.iterations);	
	}

}
