package de.lmu.ifi.pms.java.lang.iteration;

import java.util.Iterator;
import java.util.NoSuchElementException;

public class ExaminingIteratorWrapper<Type> extends AbstractExaminingIterator<Type>{
	
	private Type next;
	
	private final Iterator<Type> iterator;

	public ExaminingIteratorWrapper(final Iterator<Type> iterator) {
		super();
		this.iterator = iterator;
	}

	@Override
	public final boolean hasNext() {
		if(this.next == null){
			if(this.iterator.hasNext()){
				this.next = this.iterator.next();
			}
		}
		return this.next != null;
	}
	
	@Override
	public Type examineNext() {
		if(this.hasNext()){
			return this.next;
		}
		else{
			throw new NoSuchElementException();//TODO better exception
		}
	}
	
	@Override
	public void skipNext() {
		if(this.hasNext()){
			this.next = null;
		}
		else{
			throw new NoSuchElementException();//TODO better exception
		}
	}

	@Override
	public final Type next() {
		if(this.hasNext()){
			final Type next = this.next;
			this.next = null;
			return next;
		}
		else{
			throw new NoSuchElementException();//TODO better exception
		}
	}

}
