package de.lmu.ifi.pms.java.lang.iteration;

import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;
import de.lmu.ifi.pms.java.util.filter.Filter;

public abstract class FilteredIteration<Type> extends AbstractIterable<Type> implements Filter<Type>{

	private final Iterable<? extends Type> source;	

	public FilteredIteration(final Iterable<? extends Type> source) {
		super();
		this.source = source;
	}
	
	public FilteredIteration(final Type[] source) {
		super();
		this.source = new FixedArray<Type>(source);
	}

	@Override
	public FixedIterator<Type> iterator() {
		return new FilteredIteratorImpl<Type>(this.source.iterator(), this);
	}
		
	@Override
	public abstract boolean accepts(Type element);
	
	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final int element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final long element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final float element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final double element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final byte element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final short element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final char element) {
		return this.accepts((Type)(Object)element);
	}

	@Override
	@SuppressWarnings({ "unchecked", "cast" })
	public boolean accepts(final boolean element) {
		return this.accepts((Type)(Object)element);
	}
}
