package de.lmu.ifi.pms.java.lang.iteration;

import java.util.Iterator;

import de.lmu.ifi.pms.java.util.adaption.IterationAdapter;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;



public class FinalVectorIterable<Type> extends AbstractIterable<FixedArray<Type>> {

	private final FixedArray<? extends Iterable<Type>> iterations;

	public FinalVectorIterable(final FixedArray<? extends Iterable<Type>> iterations) {
		super();
		this.iterations = iterations;
	}
	
	@Override
	public Iterator<FixedArray<Type>> iterator() {
		return new FinalVectorIterator<Type>(new FixedArray<Iterator<Type>>(new IterationAdapter<Iterable<Type>, Iterator<Type>>(this.iterations){
			@Override
			public Iterator<Type> adapt(final Iterable<Type> iteration) {
				return iteration.iterator();
			}
		},this.iterations.size()));
	}
	
}
