package de.lmu.ifi.pms.java.lang.iteration;

import de.lmu.ifi.pms.java.util.tupel.Pair;

public class PairIterable<Type1, Type2> extends AbstractIterable<Pair<Object,Type1, Type2>>{

	private final Iterable<Type1> iterable1;
	private final Iterable<Type2> iterable2;	

	public PairIterable(final Iterable<Type1> iterable1, final Iterable<Type2> iterable2) {
		super();
		this.iterable1 = iterable1;
		this.iterable2 = iterable2;
	}
	
	public PairIterable(final Pair<Iterable<?>,Iterable<Type1>, Iterable<Type2>> pair){
		this(pair.comp0(), pair.comp1());
	}

	@Override
	public PairIterator<Type1, Type2> iterator() {
		return new PairIterator<Type1, Type2>(this.iterable1.iterator(), this.iterable2.iterator());
	}	
	
}
