/**
 * 
 */
package de.lmu.ifi.pms.java.util.adaption;

import de.lmu.ifi.pms.java.lang.iteration.AbstractExtendibleIterator;
import de.lmu.ifi.pms.java.lang.iteration.ExtendibleIterator;
import de.lmu.ifi.pms.java.lang.iteration.JavaIteratorExtendibleWrapper;


public abstract class ExtendibleIteratorAdapter<SourceType, IterationType> extends AbstractExtendibleIterator<IterationType> implements Adapter<SourceType, IterationType>{

	final ExtendibleIterator<SourceType> sourceIterator;
	
	public ExtendibleIteratorAdapter(final java.util.Collection<SourceType> javaCollection) {
		this(new JavaIteratorExtendibleWrapper<SourceType>(javaCollection));
	}
	
	public ExtendibleIteratorAdapter(final ExtendibleIterator<SourceType> sourceIterator) {
		super();
		this.sourceIterator = sourceIterator;
	}

	@Override
	public final boolean hasNext() {
		return this.sourceIterator.hasNext();
	}

	@Override
	public final IterationType next() {
		return this.adapt(this.sourceIterator.next());
	}
	
	@Override
	public void insert(final IterationType value) {
		this.sourceIterator.insert(this.inverseAdapt(value));
	}
	
	@Override
	public void remove() {
		this.sourceIterator.remove();
	}
	
	@Override
	public void replace(final IterationType newValue) {
		this.sourceIterator.replace(this.inverseAdapt(newValue));
	}
	
	
	
	@Override
	public abstract IterationType adapt(SourceType source);
	
	public abstract SourceType inverseAdapt(IterationType source);
			
}