/**
 * 
 */
package de.lmu.ifi.pms.java.util.collection;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import de.lmu.ifi.pms.java.lang.iteration.Iterator;


/**
 * @author Simon Matthias Brodt
 *
 */
public class CollectionWrapper<Type> extends AbstractCollection<Type> {
	
	private final Collection<Type> c;
	
	private final Method iterator;
	
	private final Method size;
	
	public CollectionWrapper(final Collection<Type> c){
		this.c = c;
		try {
			this.iterator = c.getClass().getMethod("iterator");
			this.size = c.getClass().getMethod("size");
		} catch (SecurityException e) {
			throw new RuntimeException(e);
		} catch (NoSuchMethodException e) {
			throw new RuntimeException(e);
		}
	}

	/* (non-Javadoc)
	 * @see extension.java.util.collection.AbstractCollection#iterator()
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Iterator<Type> iterator() {
		try {
			return (Iterator<Type>)this.iterator.invoke(this.c, (Object[]) null);
		} catch (IllegalArgumentException e) {
			throw new RuntimeException(e);
		} catch (IllegalAccessException e) {
			throw new RuntimeException(e);
		} catch (InvocationTargetException e) {
			throw new RuntimeException(e);
		}
	}

	/* (non-Javadoc)
	 * @see extension.java.util.collection.AbstractCollection#size()
	 */
	@Override
	public int size() {
		try {
			return (Integer)this.size.invoke(this.c, (Object[]) null);
		} catch (IllegalArgumentException e) {
			throw new RuntimeException(e);
		} catch (IllegalAccessException e) {
			throw new RuntimeException(e);
		} catch (InvocationTargetException e) {
			throw new RuntimeException(e);
		}
	}
	
	public static void main(final String[] args) {
		
	}

}
