package de.lmu.ifi.pms.java.util.collection.array;

import de.lmu.ifi.pms.java.lang.iteration.FixedListIterator;
import de.lmu.ifi.pms.java.util.collection.fixed.FixedCollection;

public abstract class AbstractFixedArray<Type> extends AbstractArray<Type> implements FixedCollection<Type>{

	public AbstractFixedArray() {
		
	}

	@Override
	public GenericFixedArrayIterator<Type, ? extends AbstractFixedArray<Type>> iterator() {
		return new GenericFixedArrayIterator<Type, AbstractFixedArray<Type>>(this);
	}
	
	public static class GenericFixedArrayIterator<Type, ArrayType extends AbstractFixedArray<Type>> extends ArrayIterator<Type, ArrayType> implements FixedListIterator<Type>{

		public GenericFixedArrayIterator(ArrayType array, int firstIndexInclusive, int lastIndexExclusive, int position) {
			super(array, firstIndexInclusive, lastIndexExclusive, position);
		}

		public GenericFixedArrayIterator(ArrayType array) {
			super(array);
		}
		
		/* (non-Javadoc)
		 * @see extension.java.lang.iteration.AbstractIterator#remove()
		 */
		@Override
		@Deprecated
		public final void remove() {
			throw new UnsupportedOperationException();
		}
		
		/* (non-Javadoc)
		 * @see extension.java.util.collection.array.AbstractArray.ArrayIterator#add(java.lang.Object)
		 */
		@Override
		@Deprecated
		public final void add(Type e) {
			super.add(e);
		}
		
		/* (non-Javadoc)
		 * @see extension.java.util.collection.array.AbstractArray.ArrayIterator#set(java.lang.Object)
		 */
		@Override
		@Deprecated
		public final void set(Type e) {
			super.set(e);
		}
		
	}
	
}
