package de.lmu.ifi.pms.java.util.collection.array;

import de.lmu.ifi.pms.java.lang.iteration.ModifyableIterator;

public abstract class AbstractModifyableArray<Type> extends AbstractArray<Type>{
	
	public AbstractModifyableArray(){
		
	}
	
	@Override
	public ModifyableArrayIterator<Type, ? extends AbstractModifyableArray<Type>> iterator() {
		return new ModifyableArrayIterator<Type, AbstractModifyableArray<Type>>(this);
	}
	
	public static class ModifyableArrayIterator<Type, ArrayType extends AbstractModifyableArray<Type>> extends ArrayIterator<Type, ArrayType> implements ModifyableIterator<Type>{

		public ModifyableArrayIterator(final ArrayType array, final int firstIndexInclusive, final int lastIndexExclusive, final int position) {
			super(array, firstIndexInclusive, lastIndexExclusive, position);
		}

		public ModifyableArrayIterator(final ArrayType array) {
			super(array);
		}
		
		/* (non-Javadoc)
		 * @see extension.java.lang.iteration.ModifyableIterator#replace(java.lang.Object)
		 */
		@Override
		public void replace(final Type newValue) {
			this.array.set(this.position-1, newValue);
		}
		
		@Override
		public void replace(final byte newValue) {
			this.array.set(this.position-1, newValue);
		}
		
		@Override
		public void replace(final short newValue) {
			this.array.set(this.position-1, newValue);
		}
		
		@Override
		public void replace(final int newValue) {
			this.array.set(this.position-1, newValue);
		}
		
		@Override
		public void replace(final long newValue) {
			this.array.set(this.position-1, newValue);
		}

		@Override
		public void replace(final float newValue) {
			this.array.set(this.position-1, newValue);
		}

		@Override
		public void replace(final double newValue) {
			this.array.set(this.position-1, newValue);
		}

		@Override
		public void replace(final char newValue) {
			this.array.set(this.position-1, newValue);
		}

		@Override
		public void replace(final boolean newValue) {
			this.array.set(this.position-1, newValue);
		}
		
		@SuppressWarnings("deprecation")
		@Override
		public final void set(final Type e) {
			this.replace(e);
		}
		
	}
	
	@Override
	public abstract Class<? super Type> ensuredType();
	
	public abstract void set(int index, Type value);
	
	@SuppressWarnings({ "unchecked", "cast" })
	public void set(final int index, final int value){
		this.set(index, (Type)(Object)value);
	}
	
	@SuppressWarnings({ "unchecked", "cast" })
	public void set(final int index, final long value){
		this.set(index, (Type)(Object)value);
	}
	
	@SuppressWarnings({ "unchecked", "cast" })
	public void set(final int index, final double value){
		this.set(index, (Type)(Object)value);
	}
	
	@SuppressWarnings({ "unchecked", "cast" })
	public void set(final int index, final float value){
		this.set(index, (Type)(Object)value);
	}
	
	@SuppressWarnings({ "unchecked", "cast" })
	public void set(final int index, final short value){
		this.set(index, (Type)(Object)value);
	}
	
	@SuppressWarnings({ "unchecked", "cast" })
	public void set(final int index, final byte value){
		this.set(index, (Type)(Object)value);
	}
	
	@SuppressWarnings({ "unchecked", "cast" })
	public void set(final int index, final char value){
		this.set(index, (Type)(Object)value);
	}
	
	@SuppressWarnings({ "unchecked", "cast" })
	public void set(final int index, final boolean value){
		this.set(index, (Type)(Object)value);
	}
	
	@Override
	public abstract AbstractModifyableArray<Type> subArray(int offset, int length);
	
	public void addFirstDropLast(final Type value){
		this.insertIndexDropLast(this.minIndexInc(), value);
	}
	
	public abstract void insertIndexDropLast(int index, Type value);
	
}
