package de.lmu.ifi.pms.java.util.collection.fixed.set;

import java.util.Comparator;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;
import de.lmu.ifi.pms.java.util.collection.javaWrapper.ToJavaNavigableSetWrapper;
import de.lmu.ifi.pms.java.util.collection.set.AbstractSortedSet.AbstractJavaNavigableSet;



public abstract class AbstractFixedNavigableSet<Type> extends AbstractFixedSortedSet<Type> implements FixedNavigableSet<Type> {

	@Override
	public abstract AbstractFixedIterator<Type> iterator();

	@Override
	public abstract int size();

	@Override
	public abstract Comparator<? super Type> comparator();

	@Override
	public abstract Type first();

	@Override
	public abstract FixedSortedSet<Type> headSet(Type toElement);

	@Override
	public abstract Type last();

	@Override
	public abstract FixedSortedSet<Type> subSet(Type fromElement, Type toElement);

	@Override
	public abstract FixedSortedSet<Type> tailSet(Type fromElement);
	
	@Override
	public abstract Type ceiling(Type e);
	
	@Override
	public abstract Type floor(Type e);

	@Override
	public abstract Type higher(Type e);

	@Override
	public abstract Type lower(Type e);

	@Override
	public abstract AbstractFixedIterator<Type> descendingIterator();

	@Override
	public abstract FixedNavigableSet<Type> descendingSet();

	@Override
	public abstract FixedNavigableSet<Type> headSet(Type toElement, boolean inclusive);

	@Override
	public abstract FixedNavigableSet<Type> subSet(Type fromElement, boolean fromInclusive, Type toElement, boolean toInclusive);

	@Override
	public abstract FixedNavigableSet<Type> tailSet(Type fromElement, boolean inclusive);
	
	@Override
	public AbstractJavaNavigableSet<Type> javaCollection() {
		return new ToJavaNavigableSetWrapper<Type>(this);
	}
	
}
