package de.lmu.ifi.pms.java.util.collection.fixed.wrapper;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;
import de.lmu.ifi.pms.java.lang.iteration.FinalIteratorWrapper;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.fixed.AbstractFixedCollection;


public class FixedCollectionWrapper<Type> extends AbstractFixedCollection<Type> {

	private final Collection<? extends Type> collection;	
	
	public FixedCollectionWrapper(final Collection<? extends Type> collection) {
		super();
		this.collection = collection;
	}

	@Override
	public final AbstractFixedIterator<Type> iterator() {
		return new FinalIteratorWrapper<Type>(this.collection.iterator());
	}

	@Override
	public final int size() {
		return this.collection.size();
	}

}
