package de.lmu.ifi.pms.java.util.collection.fixed.wrapper;

import java.util.Deque;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;
import de.lmu.ifi.pms.java.lang.iteration.FinalIteratorWrapper;
import de.lmu.ifi.pms.java.util.collection.fixed.AbstractFixedDeque;



public class FixedDequeWrapper<Type> extends AbstractFixedDeque<Type> {

	private final Deque<Type> collection;	
	
	public FixedDequeWrapper(final Deque<Type> collection) {
		super();
		this.collection = collection;
	}

	@Override
	public final AbstractFixedIterator<Type> iterator() {
		return new FinalIteratorWrapper<Type>(this.collection.iterator());
	}

	@Override
	public final int size() {
		return this.collection.size();
	}
	
	@Override
	public Type element() {
		return this.collection.element();
	}

	@Override
	public Type peek() {
		return this.collection.peek();
	}
	
	@Override
	public Type peekFirst() {
		return this.collection.peekFirst();
	}
	
	@Override
	public Type peekLast() {
		return this.collection.peekLast();
	}

	@Override
	public AbstractFixedIterator<Type> descendingIterator() {
		return new FinalIteratorWrapper<Type>(this.collection.descendingIterator());
	}
	
	@Override
	public Type getFirst() {
		return this.collection.getFirst();
	}
	
	@Override
	public Type getLast() {
		return this.collection.getLast();
	}
	
}
