package de.lmu.ifi.pms.java.util.collection.javaWrapper;

import java.util.Collection;

import de.lmu.ifi.pms.java.lang.iteration.FixedIterator;
import de.lmu.ifi.pms.java.lang.iteration.JavaIteratorWrapper;
import de.lmu.ifi.pms.java.util.collection.fixed.AbstractFixedCollection;


public class FromJavaCollectionWrapper<Type> extends AbstractFixedCollection<Type> {
	
	private final java.util.Collection<? extends Type> javaCollection;
	
	public FromJavaCollectionWrapper(final Collection<? extends Type> javaCollection) {
		super();
		this.javaCollection = javaCollection;
	}
	
	@Override
	public boolean contains(final Object o) {
		return this.javaCollection.contains(o);
	}
	
	@Override
	public boolean containsAll(final de.lmu.ifi.pms.java.util.collection.Collection<?> c) {
		return this.javaCollection.containsAll(c.javaCollection());
	}
	
	@Override
	public boolean isEmpty() {
		return this.javaCollection.isEmpty();
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public java.util.AbstractCollection<Type> javaCollection() {
		if(this.javaCollection instanceof java.util.AbstractCollection){
			return (java.util.AbstractCollection<Type>) this.javaCollection;
		}
		else{
			return super.javaCollection();
		}
	}
	
	
	@Override
	public Object[] toArray() {
		return this.javaCollection.toArray();
	}
	
	@Override
	public <T> T[] toArray(final T[] a) {
		return this.javaCollection.toArray(a);
	}

	@Override
	public FixedIterator<Type> iterator() {
		return new JavaIteratorWrapper<Type>(this.javaCollection.iterator());
	}

	@Override
	public final int size() {
		return this.javaCollection.size();
	}

}
