package de.lmu.ifi.pms.java.util.collection.javaWrapper;

import de.lmu.ifi.pms.java.lang.iteration.ExtendibleIterator;
import de.lmu.ifi.pms.java.lang.iteration.JavaIteratorExtendibleWrapper;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.extendible.AbstractExtendibleCollection;
import de.lmu.ifi.pms.java.util.collection.extendible.set.ExtendibleSet;

public class FromJavaExtendibleSetWrapper<Type> extends AbstractExtendibleCollection<Type> implements ExtendibleSet<Type>{
	
	private final java.util.Set<Type> javaCollection;
	
	public FromJavaExtendibleSetWrapper(final java.util.Set<Type> javaCollection) {
		super();
		this.javaCollection = javaCollection;
	}

	@Override
	public boolean contains(final Object o) {
		return this.javaCollection.contains(o);
	}
	
	@Override
	public boolean isEmpty() {
		return this.javaCollection.isEmpty();
	}
	
	@Override
	public java.util.AbstractSet<Type> javaCollection() {
		if(this.javaCollection instanceof java.util.AbstractSet){
			return (java.util.AbstractSet<Type>) this.javaCollection;
		}
		else{
			return new ToJavaSetExtendibleWrapper<Type>(this);
		}
	}
	
	@Override
	public boolean add(final Type value) {
		return this.javaCollection.add(value);
	}
	
	@Override
	public void clear() {
		this.javaCollection.clear();
	}
	
	@Override
	public boolean remove(final Object o) {
		return this.javaCollection.remove(o);
	}
	
	
	@Override
	public boolean addAll(final java.util.Collection<? extends Type> c) {
		return this.javaCollection.addAll(c);
	}

	@Override
	public boolean addAll(final de.lmu.ifi.pms.java.util.collection.Collection<? extends Type> c) {
		return this.addAll(c.javaCollection());
	}

	@Override
	public boolean removeAll(final java.util.Collection<?> c) {
		return this.javaCollection.removeAll(c);
	}
	
	@Override
	public boolean removeAll(final Collection<?> c) {
		return this.removeAll(c.javaCollection());
	}
	
	@Override
	public boolean retainAll(final java.util.Collection<?> c) {
		return this.javaCollection.retainAll(c);
	}

	@Override
	public boolean retainAll(final Collection<?> c) {
		return this.retainAll(c.javaCollection());
	}
	
	@Override
	public Object[] toArray() {
		return this.javaCollection.toArray();
	}
	
	@Override
	public <T> T[] toArray(final T[] a) {
		return this.javaCollection.toArray(a);
	}

	@Override
	public ExtendibleIterator<Type> iterator() {
		return new JavaIteratorExtendibleWrapper<Type>(this.javaCollection);
	}

	@Override
	public final int size() {
		return this.javaCollection.size();
	}

}
