package de.lmu.ifi.pms.java.util.collection.javaWrapper;

import java.util.Iterator;

import de.lmu.ifi.pms.java.util.collection.extendible.ExtendibleCollection;


public class ToJavaCollectionExtendibleWrapper<Type> extends java.util.AbstractCollection<Type> {
	
	final ExtendibleCollection<Type> collection;

	public ToJavaCollectionExtendibleWrapper(final ExtendibleCollection<Type> collection) {
		super();
		this.collection = collection;
	}

	@Override
	public Iterator<Type> iterator() {
		return this.collection.iterator();
	}

	@Override
	public int size() {
		return this.collection.size();
	}
	
	@Override
	public boolean isEmpty() {
		return this.collection.isEmpty();
	}
	
	@Override
	public String toString() {
		return this.collection.toString();
	}
	
	@Override
	public boolean contains(final Object o) {
		return this.collection.contains(o);
	}
	
	@Override
	public boolean add(final Type value) {
		return this.collection.add(value);
	}
	
	@Override
	public boolean addAll(final java.util.Collection<? extends Type> c) {
		return this.collection.addAll(c);
	}
	
	@Override
	public void clear() {
		this.collection.clear();
	}
	
	@Override
	public boolean remove(final Object o) {
		return this.collection.remove(o);
	}
	
	@Override
	public boolean removeAll(final java.util.Collection<?> c) {
		return this.collection.removeAll(c);
	}
	
	@Override
	public boolean retainAll(final java.util.Collection<?> c) {
		return this.collection.retainAll(c);
	}
	
	@Override
	public boolean containsAll(final java.util.Collection<?> c) {
		return this.collection.containsAll(c);
	}
	
	@Override
	public Object[] toArray() {
		return this.collection.toArray();
	}
	
	@Override
	public <T> T[] toArray(final T[] a) {
		return this.collection.toArray(a);
	}
	
	

}
