package de.lmu.ifi.pms.java.util.collection.javaWrapper;

import java.util.Comparator;
import java.util.Iterator;

import de.lmu.ifi.pms.development.UnimplementedMethodError;
import de.lmu.ifi.pms.java.util.collection.set.NavigableSet;
import de.lmu.ifi.pms.java.util.collection.set.AbstractSortedSet.AbstractJavaNavigableSet;


public class ToJavaNavigableSetWrapper<Type> extends AbstractJavaNavigableSet<Type> {
	
	final NavigableSet<Type> collection;

	public ToJavaNavigableSetWrapper(final NavigableSet<Type> collection) {
		super();
		this.collection = collection;
	}

	@Override
	public Iterator<Type> iterator() {
		return this.collection.iterator();
	}

	@Override
	public int size() {
		return this.collection.size();
	}
	
	@Override
	public String toString() {
		return this.collection.toString();
	}
	
	@Override
	public boolean contains(final Object o) {
		return this.collection.contains(o);
	}
	
	@SuppressWarnings({ "rawtypes", "unchecked" })
	@Override
	public boolean containsAll(final java.util.Collection<?> c) {
		return this.collection.containsAll(new FromJavaCollectionWrapper(c));
	}
	
	@Override
	public Object[] toArray() {
		return this.collection.toArray();
	}
	
	@Override
	public <T> T[] toArray(final T[] a) {
		return this.collection.toArray(a);
	}

	@Override
	public Comparator<? super Type> comparator() {
		return this.collection.comparator();
	}

	@Override
	public java.util.SortedSet<Type> subSet(final Type fromElement, final Type toElement) {
		return this.collection.subSet(fromElement, toElement).javaCollection();
	}

	@Override
	public java.util.SortedSet<Type> headSet(final Type toElement) {
		return this.collection.headSet(toElement).javaCollection();
	}

	@Override
	public java.util.SortedSet<Type> tailSet(final Type fromElement) {
		return this.collection.tailSet(fromElement).javaCollection();
	}

	@Override
	public Type first() {
		return this.collection.first();
	}

	@Override
	public Type last() {
		return this.collection.last();
	}

	@Override
	public Type lower(final Type e) {
		return this.collection.lower(e);
	}

	@Override
	public Type floor(final Type e) {
		return this.collection.floor(e);
	}

	@Override
	public Type ceiling(final Type e) {
		return this.collection.ceiling(e);
	}

	@Override
	public Type higher(final Type e) {
		return this.collection.higher(e);
	}

	@Override
	public java.util.NavigableSet<Type> descendingSet() {
		return this.collection.descendingSet().javaCollection();
	}

	@Override
	public Iterator<Type> descendingIterator() {
		return this.collection.descendingIterator();
	}

	@Override
	public java.util.NavigableSet<Type> subSet(final Type fromElement, final boolean fromInclusive, final Type toElement, final boolean toInclusive) {
		return this.collection.subSet(fromElement, fromInclusive, toElement, toInclusive).javaCollection();
	}

	@Override
	public java.util.NavigableSet<Type> headSet(final Type toElement, final boolean inclusive) {
		return this.collection.headSet(toElement, inclusive).javaCollection();
	}

	@Override
	public java.util.NavigableSet<Type> tailSet(final Type fromElement, final boolean inclusive) {
		return this.collection.tailSet(fromElement, inclusive).javaCollection();
	}
	
	@Override
	public Type pollFirst() {
		//FIXME implement
		throw new UnimplementedMethodError();
	}

	@Override
	public Type pollLast() {
		//FIXME implement
		throw new UnimplementedMethodError();
	}
	
}
