package de.lmu.ifi.pms.java.util.collection.javaWrapper;

import java.util.Iterator;

import de.lmu.ifi.pms.java.util.collection.set.Set;


public class ToJavaSetWrapper<Type> extends java.util.AbstractSet<Type> {
	
	final Set<Type> collection;

	public ToJavaSetWrapper(final Set<Type> collection) {
		super();
		this.collection = collection;
	}

	@Override
	public Iterator<Type> iterator() {
		return this.collection.iterator();
	}

	@Override
	public int size() {
		return this.collection.size();
	}
	
	@Override
	public String toString() {
		return this.collection.toString();
	}
	
	@Override
	public boolean contains(final Object o) {
		return this.collection.contains(o);
	}
	
	@SuppressWarnings({ "rawtypes", "unchecked" })
	@Override
	public boolean containsAll(final java.util.Collection<?> c) {
		return this.collection.containsAll(new FromJavaCollectionWrapper(c));
	}
	
	@Override
	public Object[] toArray() {
		return this.collection.toArray();
	}
	
	@Override
	public <T> T[] toArray(final T[] a) {
		return this.collection.toArray(a);
	}

}
