package de.lmu.ifi.pms.java.util.comparator;

import java.util.Comparator;

public abstract class AbstractComparator<Type> implements Comparator<Type> {

	@Override
	public abstract int compare(Type o1, Type o2);
	
	@SuppressWarnings("unchecked")
	public final static <Type> int compare(final Type e1, final Type e2, Comparator<? super Type> comparator){
		if(comparator == null){
			comparator = ComparableWrapper.wrapper;
		}
		return comparator.compare(e1, e2);
	}
	
	@SuppressWarnings("unchecked")
	public final static <CType extends Comparable<CType>> boolean isEquals(final Class<CType> type, final CType t, final Object o){
		if(type.isInstance(o)){
			return t.compareTo((CType)o) == 0;
		}
		else{
			return false;
		}
	}
}
