package de.lmu.ifi.pms.java.util.map;

import de.lmu.ifi.pms.java.lang.iteration.ModifyableIterator;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.set.Set;

public abstract class AbstractModifyableMap<KeyType, ValueType, EntryType extends ModifyableEntry<KeyType, ValueType>> extends
		AbstractMap<KeyType, ValueType, EntryType> implements ModifyableMap<KeyType, ValueType, EntryType>{
	
	@Override
	public abstract Set<KeyType> keys();

	@Override
	public abstract EntryType entry(KeyType key);

	@Override
	public abstract ValueType get(KeyType key);

	@Override
	public abstract boolean has(KeyType key);

	@Override
	public abstract Collection<ValueType> values();

	@Override
	public abstract ModifyableIterator<EntryType> iterator();

	@Override
	public abstract int size();	
	
	@Override
	public abstract void set(KeyType key, ValueType value);
	
	public void set(Entry<KeyType, ValueType> entry){
		set(entry.key(),entry.value());
	}

}
