/**
 * 
 */
package de.lmu.ifi.pms.java.util.map;

import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.extendible.set.ExtendibleSet;


/**
 * @author Simon Matthias Brodt
 *
 */
public interface ExtendibleMap<KeyType, ValueType, EntryType extends ExtendibleEntry<KeyType, ValueType>> extends ModifyableMap<KeyType, ValueType, EntryType>, ExtendibleSet<EntryType>{

	@Override
	void clear();
	
	boolean add(KeyType key, ValueType value);
	
	@Deprecated
	boolean put(KeyType key, ValueType value);
	
	public boolean add(java.util.Map<KeyType, ValueType> map);
	
	@Deprecated
	boolean putAll(java.util.Map<KeyType, ValueType> map);
	
	boolean add(Map<KeyType, ValueType, ?> map);
	
	boolean removeKey(KeyType key);
	
	boolean remove(Entry<KeyType, ValueType> o);
	
	@Deprecated
	@Override
	public boolean remove(Object e);
	
	@Override
	public boolean removeAll(Collection<?> c);
	
	boolean add(Entry<KeyType, ValueType> entry);
	
	@Override
	boolean add(EntryType entry);
	
	@Override
	public boolean addAll(Collection<? extends EntryType> c);
	
	@Override
	public boolean addAll(java.util.Collection<? extends EntryType> c);
	
}
