package de.lmu.ifi.pms.java.util.map;

import java.util.Comparator;

import de.lmu.ifi.pms.java.util.collection.set.SortedSet;


public interface SortedMap<KeyType, ValueType, EntryType extends Entry<KeyType, ValueType>> extends Map<KeyType, ValueType, EntryType>{

	public SortedMap<KeyType, ValueType, ?> subMap(KeyType fromKey, KeyType toKey);
	
	public SortedMap<KeyType, ValueType, ?> headMap(KeyType toKey);
	
	public SortedMap<KeyType, ValueType, ?> tailMap(KeyType fromKey);
	
	/* (non-Javadoc)
	 * @see extension.java.util.map.Map#keys()
	 */
	@Override
	public SortedSet<KeyType> keys();
	
	public Comparator<? super KeyType> comparator();
	
	@Override
	public java.util.SortedMap<KeyType, ValueType> javaMap();
	
}
