package de.lmu.ifi.pms.java.util.map.fixed;

import java.util.Map.Entry;

public class FixedEntryImpl<KeyType, ValueType> extends AbstractFixedEntry<KeyType, ValueType> implements FixedEntry<KeyType, ValueType> {
	
	protected final KeyType key;
	
	protected final ValueType value;

	public FixedEntryImpl(final Entry<? extends KeyType, ? extends ValueType> entry) {
		this(entry.getKey(), entry.getValue());
	}

	public FixedEntryImpl(final KeyType key, final ValueType value) {
		this.key = key;
		this.value = value;
	}
	
	/* (non-Javadoc)
	 * @see extension.java.util.map.Entry#key()
	 */
	@Override
	public KeyType key() {
		return this.key;
	}
	
	/* (non-Javadoc)
	 * @see extension.java.util.map.Entry#value()
	 */
	@Override
	public ValueType value() {
		return this.value;
	}
	
}
