package de.lmu.ifi.pms.java.util.map.fixed;

import de.lmu.ifi.pms.java.util.collection.fixed.set.FixedNavigableSet;
import de.lmu.ifi.pms.java.util.map.NavigableMap;


public interface FixedNavigableMap<KeyType, ValueType, EntryType extends FixedEntry<KeyType, ValueType>> extends FixedSortedMap<KeyType, ValueType, EntryType>, NavigableMap<KeyType, ValueType, EntryType>{
	
	@Override
	public FixedEntry<KeyType, ValueType> lowerEntry(KeyType key);

	@Override
	public FixedEntry<KeyType, ValueType> ceilingEntry(KeyType key);

	@Override
	public FixedEntry<KeyType, ValueType> higherEntry(KeyType key);

	@Override
	public FixedEntry<KeyType, ValueType> floorEntry(KeyType key);


	@Deprecated
	@Override
	public FixedNavigableSet<KeyType> descendingKeySet();
	
	@Override
	public FixedNavigableMap<KeyType, ValueType, ?> descendingMap();
	
	@Override
	public FixedNavigableMap<KeyType, ValueType, ?> headMap(KeyType toKey);
	
	@Override
	public FixedNavigableMap<KeyType, ValueType, ?> headMap(KeyType toKey, boolean inclusive);
	
	@Override
	public FixedNavigableMap<KeyType, ValueType, ?> tailMap(KeyType fromKey, boolean inclusive);
	
	@Override
	public FixedNavigableMap<KeyType, ValueType, ?> tailMap(KeyType fromKey);
	
	@Override
	public FixedNavigableMap<KeyType, ValueType, ?> subMap(KeyType fromKey, KeyType toKey);
	
	@Override
	public FixedNavigableMap<KeyType, ValueType, ?> subMap(KeyType fromKey, boolean fromInclusive, KeyType toKey, boolean toInclusive);
	
	@Override
	public FixedEntry<KeyType, ValueType> firstEntry();
	
	@Override
	public FixedEntry<KeyType, ValueType> lastEntry();
	
	@Deprecated
	@Override
	public FixedNavigableSet<KeyType> navigableKeySet();
	
}
