/**
 * 
 */
package de.lmu.ifi.pms.java.util.map.javaWrapper;

import java.util.Map.Entry;

import de.lmu.ifi.pms.java.util.map.AbstractExtendibleEntry;


/**
 * @author Simon Matthias Brodt
 *
 */
public class FromJavaEntryExtendibleWrapper<KeyType, ValueType> extends
		AbstractExtendibleEntry<KeyType, ValueType> {
	
	final java.util.Map.Entry<KeyType, ValueType> javaEntry;
	final java.util.Map<KeyType, ValueType> map;

	public FromJavaEntryExtendibleWrapper(final Entry<KeyType, ValueType> javaEntry, final java.util.Map<KeyType, ValueType> map) {
		super();
		this.javaEntry = javaEntry;
		this.map = map;
	}
	
	/* (non-Javadoc)
	 * @see extension.java.util.map.AbstractModifyableEntry#isRemoved()
	 */
	@Override
	public boolean isRemoved() {
		return !this.map.containsKey(this.javaEntry.getKey());
	}

	/* (non-Javadoc)
	 * @see extension.java.util.map.AbstractModifyableEntry#remove()
	 */
	@Override
	public void remove() {
		this.map.remove(this.javaEntry.getKey());
	}

	/* (non-Javadoc)
	 * @see extension.java.util.map.AbstractModifyableEntry#setValue(java.lang.Object)
	 */
	@Override
	public void setValue(final ValueType newValue) {
		this.javaEntry.setValue(newValue);
	}

	/* (non-Javadoc)
	 * @see extension.java.util.map.AbstractEntry#key()
	 */
	@Override
	public KeyType key() {
		return this.javaEntry.getKey();
	}

	/* (non-Javadoc)
	 * @see extension.java.util.map.AbstractEntry#value()
	 */
	@Override
	public ValueType value() {
		return this.javaEntry.getValue();
	}

}
