/**
 * 
 */
package de.lmu.ifi.pms.java.util.map.javaWrapper;

import java.util.Map.Entry;

import de.lmu.ifi.pms.java.util.map.fixed.AbstractFixedEntry;


/**
 * @author Simon Matthias Brodt
 *
 */
public class FromJavaEntryFixedWrapper<KeyType, ValueType> extends
	AbstractFixedEntry<KeyType, ValueType> {
	
	final java.util.Map.Entry<KeyType, ValueType> javaEntry;

	public FromJavaEntryFixedWrapper(Entry<KeyType, ValueType> javaEntry) {
		super();
		this.javaEntry = javaEntry;
	}

	/* (non-Javadoc)
	 * @see extension.java.util.map.AbstractEntry#key()
	 */
	@Override
	public KeyType key() {
		return this.javaEntry.getKey();
	}

	/* (non-Javadoc)
	 * @see extension.java.util.map.AbstractEntry#value()
	 */
	@Override
	public ValueType value() {
		return this.javaEntry.getValue();
	}

}
