/**
 * 
 */
package de.lmu.ifi.pms.java.util.map.javaWrapper;

import java.util.Map.Entry;

import de.lmu.ifi.pms.java.util.map.AbstractModifyableEntry;


/**
 * @author Simon Matthias Brodt
 *
 */
public class FromJavaEntryModifyableWrapper<KeyType, ValueType> extends
		AbstractModifyableEntry<KeyType, ValueType> {
	
	final java.util.Map.Entry<KeyType, ValueType> javaEntry;

	public FromJavaEntryModifyableWrapper(Entry<KeyType, ValueType> javaEntry) {
		super();
		this.javaEntry = javaEntry;
	}

	/* (non-Javadoc)
	 * @see extension.java.util.map.AbstractModifyableEntry#setValue(java.lang.Object)
	 */
	@Override
	public void setValue(ValueType newValue) {
		this.javaEntry.setValue(newValue);
	}

	/* (non-Javadoc)
	 * @see extension.java.util.map.AbstractEntry#key()
	 */
	@Override
	public KeyType key() {
		return this.javaEntry.getKey();
	}

	/* (non-Javadoc)
	 * @see extension.java.util.map.AbstractEntry#value()
	 */
	@Override
	public ValueType value() {
		return this.javaEntry.getValue();
	}

}
