package de.lmu.ifi.pms.java.util.stream;

import java.util.Iterator;

import de.lmu.ifi.pms.java.lang.iteration.FinalVectorIterator;
import de.lmu.ifi.pms.java.util.adaption.CollectionAdapter;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;
import de.lmu.ifi.pms.java.util.stream.io.AbstractResourceCloseable;


public class CollectionStream<Type> extends AbstractResourceCloseable<Collection<SourceStream<Type>>> implements SourceStream<Collection<Type>> {
	
	private final Collection<SourceStream<Type>> streams;
	
	public CollectionStream(final Collection<SourceStream<Type>> streams) {
		super();
		this.streams = streams;
	}
	
	@Override
	public Object closeLock() {
		return this;
	}

	@Override
	public Collection<SourceStream<Type>> resources() {
		return this.streams;
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public Source<Collection<Type>> iterator() {
		if(this.isOpen()){
			//TODO good implementation?
			return (Source<Collection<Type>>)(Source<? extends Collection<Type>>) new FinalVectorIterator<Type>(new FixedArray<Iterator<Type>>(new CollectionAdapter<SourceStream<Type>, Iterator<Type>>(this.streams){
				@Override
				public Iterator<Type> adapt(final SourceStream<Type> source) {
					return source.iterator();
				}
			}));
		}
		else {
			throw new IllegalStateException();//TODO better exception
		}
	}

	@Override
	public Source<Collection<Type>> source() {
		return this.iterator();
	}

}
