package de.lmu.ifi.pms.java.util.stream;

import java.io.Closeable;

import de.lmu.ifi.pms.java.util.stream.io.AbstractResourceCloseable;
import de.lmu.ifi.pms.java.util.tupel.Tupel;


public class SourceStreamWrapper<Type> extends AbstractResourceCloseable<Tupel<Closeable>> implements SourceStream<Type> {
	
	private final Source<Type> source;

	public SourceStreamWrapper(final Source<Type> source) {
		super();
		this.source = source;
	}

	@Override
	public Source<Type> iterator() {
		return this.source();
	}
	
	@Override
	public Object closeLock() {
		return this;
	}

	@Override
	public Source<Type> source() {
		if(this.isOpen()){
			return this.source;	
		}
		else{
			throw new IllegalArgumentException();
		}
	}
	
	@Override
	public Tupel<Closeable> resources() {
		return Tupel.EMPTY();
	}

}
