package de.lmu.ifi.pms.java.util.wrapper;

import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.fixed.FixedCollection;
import de.lmu.ifi.pms.java.util.collection.fixed.wrapper.FixedCollectionWrapper;
import de.lmu.ifi.pms.java.util.collection.javaWrapper.FromJavaCollectionWrapper;
import de.lmu.ifi.pms.java.util.map.ExtendibleMap;
import de.lmu.ifi.pms.java.util.map.ExtendibleNavigableMap;
import de.lmu.ifi.pms.java.util.map.ExtendibleSortedMap;
import de.lmu.ifi.pms.java.util.map.javaWrapper.FromJavaMapExtendibleWrapper;
import de.lmu.ifi.pms.java.util.map.javaWrapper.FromJavaNavigableMapExtendibleWrapper;
import de.lmu.ifi.pms.java.util.map.javaWrapper.FromJavaSortedMapExtendibleWrapper;

public final class Wrapper {

	private Wrapper(){}	
	
	public static <KeyType, ValueType> ExtendibleMap<KeyType, ValueType, ?> Enclose(java.util.Map<KeyType, ValueType> map){
		if(map instanceof java.util.SortedMap<?,?>){
			return Enclose((java.util.SortedMap<KeyType,ValueType>)map);
		}
		else{
			return new FromJavaMapExtendibleWrapper<KeyType, ValueType>(map);
		}
	}
	
	public static <KeyType, ValueType> ExtendibleSortedMap<KeyType, ValueType, ?> Enclose(java.util.SortedMap<KeyType, ValueType> map){
		if(map instanceof java.util.NavigableMap<?,?>){
			return Enclose((java.util.NavigableMap<KeyType,ValueType>)map);
		}
		else{
			return new FromJavaSortedMapExtendibleWrapper<KeyType, ValueType>(map);
		}
	}
	
	public static <KeyType, ValueType> ExtendibleNavigableMap<KeyType, ValueType, ?> Enclose(java.util.NavigableMap<KeyType, ValueType> map){
		return new FromJavaNavigableMapExtendibleWrapper<KeyType, ValueType>(map);
	}
	
	//Collection Wrapper
	
	public static <Type> FixedCollection<Type> Fix(java.util.Collection<Type> javaCollection){
		return Fix(new FromJavaCollectionWrapper<Type>(javaCollection));
		//TODO improve
	}
	
	public static <Type> FixedCollection<Type> Fix(Collection<Type> collection){
		return new FixedCollectionWrapper<Type>(collection);
		//TODO improve
	}
	
}
